/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETMOTORCONTROL_H_
#define _PHIDGETMOTORCONTROL_H_

typedef struct _PhidgetMotCon PhidgetMotCon;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an MotorControl. Additionally contains semaphores
// concerning inputs, current draw and the change of velocity
//

struct _PhidgetMotCon {
	CPhidgetMotorControlHandle handle;	// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int	iSemaphoreAttach;				// semaphore index for Motor Control attachment
	int iSemaphoreDetach;				// semaphore index for Motor Control detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int	iSemaphoreVelocityChange;		// semaphore index for a change of the velocity of a motor
	int iSemaphoreCurrentChange;		// semaphore index for a change of the current draw of a motor
	int iSemaphoreInputChange;			// semaphore index to signal when a digital output changed
};

// methods
sqInt phidgetMotCon_GetNewId();
void phidgetMotCon_ResetSemaphores(PhidgetMotCon* pPhidget);
BOOL phidgetMotCon_Close(PhidgetMotCon* pPhidget);
BOOL phidgetMotCon_Open(PhidgetMotCon* pPhidget);

#endif //_PHIDGETMOTORCONTROL_H_
